#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_RobotsCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<M_RobotsCFG> M_RobotsCFG::msSingleton(nullptr);

int M_RobotsCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_RobotsCFGData* M_RobotsCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_RobotsCFGData>& M_RobotsCFG::GetMapData()
{
	return mMapData;
}

void M_RobotsCFG::Reload()
{
	mMapData.clear();
	Load();
}

void M_RobotsCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_RobotsCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mRankingTyep = element->IntAttribute("RankingTyep");
		{
			const char* Time = element->Attribute("Time");
			std::vector<std::string> vecTime;
			boost::split(vecTime, Time, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecTime.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecTime[i].c_str(), &temp))
				{
					data.mTime.push_back(temp);
				}
			}
		}
		{
			const char* NumberOfRobots = element->Attribute("NumberOfRobots");
			std::vector<std::string> vecNumberOfRobots;
			boost::split(vecNumberOfRobots, NumberOfRobots, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecNumberOfRobots.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecNumberOfRobots[i].c_str(), &temp))
				{
					data.mNumberOfRobots.push_back(temp);
				}
			}
		}
		data.mMin = element->IntAttribute("Min");
		data.mMax = element->IntAttribute("Max");
		data.mCreateHisCountMin = element->IntAttribute("CreateHisCountMin");
		data.mCreateHisCountMax = element->IntAttribute("CreateHisCountMax");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void M_RobotsCFG::Load()
{
	Load("../Config/M_RobotsCFG.xml");
}

M_RobotsCFG* M_RobotsCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_RobotsCFG());
	}
	return msSingleton.get();
}
